diff -ur xpdf-orig/configure.in xpdf-3.02/configure.in
--- xpdf-orig/configure.in	2007-02-27 23:05:51.000000000 +0100
+++ xpdf-3.02/configure.in	2007-08-06 13:41:05.000000000 +0200
@@ -10,31 +10,31 @@
 AC_ARG_ENABLE(a4-paper,
 [  --enable-a4-paper       use A4 paper size instead of Letter for
                           PostScript output],
-AC_DEFINE(A4_PAPER))
+AC_DEFINE([A4_PAPER], [1], [use A4 paper size]))
 AC_ARG_ENABLE(no-text-select,
 [  --enable-no-text-select do not allow text selection],
-AC_DEFINE(NO_TEXT_SELECT))
+AC_DEFINE([NO_TEXT_SELECT], [1], [do not allow text selection]))
 AC_ARG_ENABLE(opi,
 [  --enable-opi            include support for OPI comments],
-AC_DEFINE(OPI_SUPPORT))
+AC_DEFINE([OPI_SUPPORT], [1], [include support for OPI comments]))
 AC_ARG_ENABLE(multithreaded,
 [  --enable-multithreaded  include support for multithreading],
-AC_DEFINE(MULTITHREADED))
+AC_DEFINE([MULTITHREADED], [1], [include support for multithreading]))
 AC_ARG_ENABLE(exceptions,
 [  --enable-exceptions     use C++ exceptions],
 AC_DEFINE(USE_EXCEPTIONS))
 AC_ARG_ENABLE(wordlist,
 [  --enable-wordlist       include support for building word lists],
-AC_DEFINE(TEXTOUT_WORD_LIST))
+AC_DEFINE([TEXTOUT_WORD_LIST], [1], [include support for building word lists]))
 AC_ARG_ENABLE(fixedpoint,
 [  --enable-fixedpoint     use fixed point (instead of floating point) arithmetic],
-AC_DEFINE(USE_FIXEDPOINT))
+AC_DEFINE([USE_FIXEDPOINT], [1], [use fixedpoint]))
 AC_ARG_ENABLE(cmyk,
 [  --enable-cmyk           include support for CMYK rasterization],
 AC_DEFINE(SPLASH_CMYK))
 AC_ARG_WITH(appdef-dir,
 [  --with-appdef-dir       set app-defaults directory],
-AC_DEFINE_UNQUOTED(APPDEFDIR, "$with_appdef_dir"))
+AC_DEFINE_UNQUOTED(APPDEFDIR, ["$with_appdef_dir"], [set app-defaults directory]))
 
 dnl ##### Path to xpdfrc.
 dnl This ugly kludge to get the sysconfdir path is needed because
@@ -48,7 +48,7 @@
 else
   system_xpdfrc="$sysconfdir/xpdfrc"
 fi
-AC_DEFINE_UNQUOTED(SYSTEM_XPDFRC, "$system_xpdfrc")
+AC_DEFINE_UNQUOTED([SYSTEM_XPDFRC], ["$system_xpdfrc"], [system_xpdfrc])
 
 dnl ##### Checks for programs.
 AC_PROG_CC
@@ -132,7 +132,7 @@
     [fd_set fds;
 select(0, NULL, NULL, NULL, NULL);], xpdf_ok=yes, xpdf_ok=no)
   if test $xpdf_ok = yes; then
-    AC_DEFINE(HAVE_SYS_SELECT_H)
+    AC_DEFINE([HAVE_SYS_SELECT_H], [1], [need sys/select.h])
     AC_MSG_RESULT([need sys/select.h])
   else
     AC_TRY_COMPILE([#include <stdlib.h>
@@ -143,7 +143,7 @@
       [fd_set fds;
 select(0, NULL, NULL, NULL, NULL);], xpdf_ok=yes, xpdf_ok=no)
     if test $xpdf_ok = yes; then
-      AC_DEFINE(HAVE_SYS_BSDTYPES_H)
+      AC_DEFINE([HAVE_SYS_BSDTYPES_H], [1], [need sys/bsdtypes.h])
       AC_MSG_RESULT([need sys/bsdtypes.h])
     else
       AC_MSG_RESULT([problem])
@@ -170,7 +170,7 @@
 #endif],
     [fd_set fds; FD_ZERO(&fds);], xpdf_ok=yes, xpdf_ok=no)
   if test $xpdf_ok = yes; then
-    AC_DEFINE(HAVE_STRINGS_H)
+    AC_DEFINE([HAVE_STRINGS_H], [1], [need strings.h])
     AC_MSG_RESULT([need strings.h])
   else
     AC_TRY_COMPILE([#include <stdlib.h>
@@ -181,7 +181,7 @@
 #endif],
       [fd_set fds; FD_ZERO(&fds);], xpdf_ok=yes, xpdf_ok=no)
     if test $xpdf_ok = yes; then
-      AC_DEFINE(HAVE_BSTRING_H)
+      AC_DEFINE([HAVE_BSTRING_H], [1], [need bstring.h])
       AC_MSG_RESULT([need bstring.h])
     else
       AC_MSG_RESULT([problem])
@@ -207,7 +207,7 @@
 [mkstemp("foo");],
 xpdf_cv_func_mkstemp=yes, xpdf_cv_func_mkstemp=no)])
 if test "$xpdf_cv_func_mkstemp" = yes; then
-  AC_DEFINE(HAVE_MKSTEMP)
+  AC_DEFINE([HAVE_MKSTEMP], [1], [have mkstemp])
 fi
 dnl # Check for mkstemps, just like mkstemp.
 AC_CACHE_CHECK([for mkstemps],
@@ -217,7 +217,7 @@
 [mkstemps("foo", 0);],
 xpdf_cv_func_mkstemps=yes, xpdf_cv_func_mkstemps=no)])
 if test "$xpdf_cv_func_mkstemps" = yes; then
-  AC_DEFINE(HAVE_MKSTEMPS)
+  AC_DEFINE([HAVE_MKSTEMPS], [1], [have mkstemps])
 fi
 
 dnl ##### Check select argument type: on HP-UX before version 10, select
@@ -234,7 +234,7 @@
 select(1, &fds, &fds, &fds, 0);],
 xpdf_cv_func_select_arg=yes, xpdf_cv_func_select_arg=no)])
 if test "$xpdf_cv_func_select_arg" != yes; then
-  AC_DEFINE(SELECT_TAKES_INT)
+  AC_DEFINE([SELECT_TAKES_INT], [1], [select takes fd_set arguments])
 fi
 
 dnl ##### Back to C for the library tests.
@@ -247,7 +247,7 @@
 AC_CHECK_FUNCS(fseek64, xpdf_cv_func_fseek64=yes, xpdf_cv_func_fseek64=no)
 AC_CHECK_FUNCS(ftell64, xpdf_cv_func_ftell64=yes, xpdf_cv_func_ftell64=no)
 if test "$xpdf_cv_func_fseek64" = yes -a "$xpdf_cv_func_ftell64" = yes; then
-  AC_DEFINE(HAVE_FSEEK64)
+  AC_DEFINE([HAVE_FSEEK64], [1], [have fseek64])
 fi
 
 dnl ##### Check for libXpm.
@@ -257,6 +257,7 @@
                 $X_LIBS $X_PRE_LIBS $X_EXTRA_LIBS -lX11, $X_CFLAGS)
   AC_SUBST(Xpm_LIBS)
   AC_SUBST(Xpm_CFLAGS)
+  AC_DEFINE([HAVE_X11_XPM_H], [1], [have X11/xpm.h])
 fi
 
 dnl ##### Check for Motif (libXm).
@@ -294,7 +295,7 @@
   dnl # check for XtAppSetExitFlag, which didn't exist prior to X11R6 (?)
   if test "x$smr_have_Xt_library" = xyes; then
     AC_CHECK_LIB(Xt, XtAppSetExitFlag,
-		 AC_DEFINE(HAVE_XTAPPSETEXITFLAG), ,
+		 AC_DEFINE(HAVE_XTAPPSETEXITFLAG, [1], [have XtAppSetExitFlag]), ,
                  [$Xt_LIBS $X_LIBS $X_PRE_LIBS $Xp_LIBS $Xext_LIBS $X_EXTRA_LIBS -lX11])
   fi
 fi
@@ -314,7 +315,7 @@
 AC_SUBST(freetype2_LIBS)
 AC_SUBST(freetype2_CFLAGS)
 if test "x$smr_have_freetype2_library" = xyes; then
-  AC_DEFINE(HAVE_FREETYPE_FREETYPE_H)
+  AC_DEFINE([HAVE_FREETYPE_FREETYPE_H], [1], [have freetype/freetype.h])
   AC_DEFINE(HAVE_SPLASH)
 fi
 